import { Component, h, Prop, State } from '@stencil/core';
import { randomIdGenerator } from '../../../global/utils/randomIdGenerator';

@Component({
	tag: 'digi-icon-accessibility-deaf',
	styleUrl: 'icon-accessibility-deaf.scss',
	scoped: true
})
export class IconAccessibilityDeaf {
	/**
	 * Lägger till ett titleelement i svg:n
	 * @en Adds a title element inside the svg
	 */
	@Prop() afTitle: string;

	/**
	 * Lägger till ett descelement i svg:n
	 * @en Adds a desc element inside the svg
	 */
	@Prop() afDesc: string;

	/**
	 * För att dölja ikonen för skärmläsare. Default är satt till true.
	 * @en Hides the icon for screen readers. Default is set to true.
	 */
	@Prop() afSvgAriaHidden: boolean = true;

	

	/**
* Referera till andra element på sidan för att definiera ett tillgängligt namn.
* @en Reference other elements on the page to define an accessible name.
*/
@Prop() afSvgAriaLabelledby: string;

@State() titleId: string = randomIdGenerator('icontitle');

	render() {
		return (
			<svg
				class="digi-icon-accessibility-deaf"
				width="48"
				height="48"
				viewBox="0 0 48 48"
				aria-hidden={this.afSvgAriaHidden ? 'true' : 'false'}
				aria-labelledby={this.afSvgAriaLabelledby ? this.afSvgAriaLabelledby : this.afTitle ? this.titleId : undefined}
				xmlns="http://www.w3.org/2000/svg"
			>
				{this.afTitle && <title id={this.titleId}>{this.afTitle}</title>}
				{this.afDesc && <desc>{this.afDesc}</desc>}
				<path
					class="digi-icon-accessibility-deaf__shape"
					d="M17.7327245,48 C16.4900679,48 15.4827238,46.9926559 15.4827238,45.7499993 C15.4827238,44.5073426 16.4900679,43.4999985 17.7327245,43.4999985 C21.1445694,43.4999985 23.9202265,40.6859976 23.9202265,37.2272778 L23.920414,37.1959653 C24.0147266,30.4331193 30.7500012,29.327244 30.7500012,24.7499925 C30.7500012,18.476428 25.7346646,13.4999874 19.5000063,13.4999874 C13.2768793,13.4999874 8.25000122,18.464053 8.25000122,24.7499925 C8.25000122,25.9926491 7.24265861,26.9999874 6.00000195,26.9999874 C4.7573453,26.9999874 3.75000122,25.9926491 3.75000122,24.7499925 C3.75000122,15.9995522 10.768691,8.99998739 19.5000063,8.99998739 C28.2159467,8.99998739 35.2500115,15.9828646 35.2500115,24.7499925 C35.2500115,31.749276 28.490728,32.9845264 28.420228,37.245184 C28.4102905,43.1769359 23.6197577,48 17.7327245,48 Z M27.7500037,24.7499925 C27.7500037,20.2009598 24.0490391,16.4999898 19.5000063,16.4999898 C14.9509736,16.4999898 11.2500037,20.2009598 11.2500037,24.7499925 C11.2500037,25.9926491 12.2573477,26.9999898 13.5000044,26.9999898 C14.742661,26.9999898 15.7500037,25.9926491 15.7500037,24.7499925 C15.7500037,22.6822418 17.4322557,20.9999898 19.5000063,20.9999898 C21.567757,20.9999898 23.2500037,22.6822418 23.2500037,24.7499925 C23.2500037,25.9926491 24.2573516,26.9999898 25.5000083,26.9999898 C26.742665,26.9999898 27.7500037,25.9926491 27.7500037,24.7499925 Z M40.0303255,18.0937403 C41.1497009,17.5542089 41.6198573,16.2093647 41.0803259,15.0899894 C39.4672628,11.743207 37.0557308,8.77086232 34.1067298,6.49423658 C33.1228233,5.73495508 31.7101041,5.91673639 30.9507288,6.90045546 C30.1913536,7.88417453 30.3732286,9.29698749 31.356854,10.0564565 C33.7550735,11.9078321 35.7155741,14.3240516 37.0265745,17.0438337 C37.566481,18.1637716 38.9117939,18.6329905 40.0303255,18.0937403 Z M46.7244527,14.7778018 C47.8442968,14.2393016 48.3157657,12.8950199 47.7772655,11.775082 C45.5383273,7.11776803 42.5447951,3.31498555 38.8788877,0.472109633 C37.8968561,-0.289328113 36.4836681,-0.110828055 35.7219491,0.871297262 C34.9605114,1.85323508 35.1391989,3.26661054 36.1211368,4.02814203 C39.2308253,6.43967406 41.7876698,9.70208137 43.721733,13.7248952 C44.2602332,14.8451143 45.6046086,15.3160207 46.7244527,14.7778018 Z M19.5000063,26.249993 C18.2573497,26.249993 17.2500056,27.257337 17.2500056,28.4999937 C17.2500056,29.7426503 18.2573497,30.749993 19.5000063,30.749993 C20.742663,30.749993 21.7500056,29.7426503 21.7500056,28.4999937 C21.7500056,27.257337 20.742663,26.249993 19.5000063,26.249993 Z M13.5000044,32.2499949 C12.2573477,32.2499949 11.2500037,33.257339 11.2500037,34.4999956 C11.2500037,35.7426523 12.2573477,36.7499949 13.5000044,36.7499949 C14.742661,36.7499949 15.7500037,35.7426523 15.7500037,34.4999956 C15.7500037,33.257339 14.742661,32.2499949 13.5000044,32.2499949 Z M2.25000073,43.4999985 C1.00734408,43.4999985 0,44.5073426 0,45.7499993 C0,46.9926559 1.00734408,47.9999985 2.25000073,47.9999985 C3.49265739,47.9999985 4.5,46.9926559 4.5,45.7499993 C4.5,44.5073426 3.49265739,43.4999985 2.25000073,43.4999985 Z M12.0910352,41.9089648 L6.09103323,35.9089648 L2.90906345,39.0909346 L8.90906345,45.0909366 L12.0910352,41.9089648 Z"
					fill="currentColor"
					fill-rule="nonzero"
				/>
			</svg>
		);
	}
}
